AG Studio: Build dashboards using native components in web apps. Join us for a webinar on 28th July at 2pm UTC+1 Register

Angular Data GridCustom Components

You can create your own Custom Components to customise the behaviour of the grid. For example you can customise how cells are rendered, how values are edited and also create your own filters.

Angular Custom Components thumbnail

The full list of component types you can provide in the grid are as follows:

The remainder of this page gives information that is common across all the component types.

Registering Custom Components Copy Link

There are two ways to register custom components:

  • Direct reference.
  • By name.

1. By Direct Reference Copy Link

When registering an Angular Component by reference you simply pass the Component to the place you want it used (i.e. Cell Renderer, Filter etc).

In this example we're specifying that we want our Angular CubeComponent as a Cell Renderer in the Cube column:

//...other imports
import { Component } from '@angular/core';
import { CubeComponent } from './cube.component';

@Component({
selector: 'app-root',
template: `
  <ag-grid-angular [columnDefs]="columnDefs"
                   ...other properties />
`
})
export class AppComponent {
  columnDefs: [
      {
          field: "cube",
          cellRenderer: CubeComponent,
      }
  ]

  //...other properties & methods
}

The advantage of referencing Components directly is cleaner code, without the extra level of indirection added when referencing by name.

2. By Name Copy Link

When registering an Angular component by name you need to first register the component within the grid components property, then reference the component by name where you want it used (i.e. as a Cell Renderer, Filter etc).

In this example we've registered our Angular CubeComponent and given it a name of cubeComponent (this can be any name you choose). We then specify that we want the previously registered cubeComponent to be used as a Cell Renderer in the Cube column:

//...other imports
import { Component } from '@angular/core';
import { CubeComponent } from './cube.component';

@Component({
selector: 'app-root',
template: `
  <ag-grid-angular [columnDefs]="columnDefs" [components]="components"
                   ...other properties />
`
})
export class AppComponent {
  components = {
      'cubeComponent': CubeComponent
  };
  columnDefs = [
      {
          field: "cube",
          cellRenderer: 'cubeComponent',
      }
  ]

  //...other properties & methods
}

The advantage of referencing components by name is definitions (eg Column Definitions) can be composed of simple types (ie JSON), which is useful should you wish to persist Column Definitions.

Clicking on the Push For Total button will log results in the developer console.

Providing Additional Parameters Copy Link

Each Custom Component gets a set of parameters from the grid. For example, for Cell Component the grid provides, among other things, the value to be rendered. You can provide additional properties to the Custom Component (e.g. what currency symbol to use) by providing additional parameters specific to your application.

To provide additional parameters, use the property [prop-name]Params, e.g. cellRendererParams.

<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'price',
        cellRenderer: PriceCellRenderer,
        cellRendererParams: {
            currency: 'EUR'
        }
    },
];

Component Lifecycle Hook agInit Copy Link

Each custom Angular component must implement the agInit(params) lifecycle hook. AgInit is called by AG Grid before any of the Angular Lifecycle hooks, including ngOnInit. This order is deterministic and applies to all component types.

Mixing JavaScript and Angular Copy Link

When providing Custom Components you have a choice of the following:

  1. Provide an AG Grid component as an Angular Component.
  2. Provide an AG Grid component in JavaScript.

The following code snippet shows how both JavaScript and Angular Components can be used at the same time:

//...other imports
import { Component } from '@angular/core';
import JavascriptComponent from './JavascriptComponent.js';
import { AngularComponent }  from './angular.component';

@Component({
selector: 'app-root',
template: `
  <ag-grid-angular [columnDefs]="columnDefs" [components]="components"
                   ...other properties />
`
})
export class AppComponent {
  // JS and Angular components, only need register if looking up by name
  components = {
      'javascriptComponent': JavascriptComponent,
      'angularComponent': AngularComponent
  };
  columnDefs = [
      {
          headerName: "JS Cell",
          field: "value",
          cellRenderer: 'javascriptComponent', // JS comp by Name
      },
      {
          headerName: "JS Cell",
          field: "value",
          cellRenderer: JavascriptComponent, // JS comp by Direct Reference
      },
      {
          headerName: "Angular Cell",
          field: "value",
          cellRenderer: 'angularComponent', // Angular comp by Name
      },
      {
          headerName: "Angular Cell",
          field: "value",
          cellRenderer: AngularComponent, // Angular comp by Direct Reference
      }
  ];

  //...other properties & methods
}

Javascript components are run outside of NgZone. If they initiate calls into your Angular application you may need to wrap these calls within ngZone.run() for Change Detection to correctly run.

Change the documentation view to JavaScript to see how to create a plain JavaScript component.

Child to Parent Communication Copy Link

There are a variety of ways to manage component communication in Angular (shared service, local variables etc), but you often need a simple way to let a "parent" component know that something has happened on a "child" component. In this case the simplest route is to use the Grid's context feature to hold a reference to the parent, which the child can then access.

//...other imports
import {Component} from '@angular/core';
import {ICellRendererAngularComp} from 'ag-grid-angular';
import {CubeComponent} from './cube.component';

@Component({
  selector: 'app-root',
  template: `
      <ag-grid-angular [context]="context" /* ...other properties */ />
  `
})
export class AppComponent {
  constructor() {
      this.context = {
          componentParent: this
      }
  }

  parentMethod() {
      // do something
  }
  //...other properties & methods
}

@Component({
  selector: 'cell-renderer',
  template: `
      ...component template...
  `
})
export class CellRendererComponent implements ICellRendererAngularComp {
  params: any;
  componentParent: any;

  agInit(params) {
      this.params = params;
      this.componentParent = this.params.context.componentParent;
      // the grid component can now be accessed - for example: this.componentParent.parentMethod()
  }

  //...other properties & methods
}

Note that although we've used componentParent as the property name here it can be anything - the main point is that you can use the context mechanism to share information between the components.

Component Usage Copy Link

The below table gives a summary of the components, where they are configured and using what attribute.

ComponentWhereAttribute
Cell ComponentColumn DefinitioncellRenderer
cellRendererParams
cellRendererSelector
Editor ComponentColumn DefinitioncellEditor
cellEditorParams
cellEditorSelector
FilterColumn Definitionfilter
filterParams
Floating FilterColumn DefinitionfloatingFilter
floatingFilterParams
Date ComponentColumn DefinitiondateComponent
dateComponentParams
Header ComponentColumn DefinitionheaderComponent
headerComponentParams
Inner Header ComponentColumn DefinitioninnerHeaderComponent
innerHeaderComponentParams
Header Group ComponentColumn DefinitionheaderGroupComponent
headerGroupComponentParams
Inner Header Group ComponentColumn DefinitioninnerHeaderGroupComponent
innerHeaderGroupComponentParams
Tooltip ComponentColumn DefinitiontooltipComponent
tooltipComponentParams
Group Row Cell ComponentGrid OptiongroupRowRenderer
groupRowRendererParams
Group Row Inner Cell ComponentcellRendererParams
groupRowRendererParams
innerRenderer
innerRendererParams
Detail Cell ComponentGrid OptiondetailCellRenderer
detailCellRendererParams
Full Width Cell ComponentGrid OptionfullWidthCellRenderer
fullWidthCellRendererParams
Loading Cell ComponentGrid Option
Column Definition
loadingCellRenderer
loadingCellRendererParams
Overlay ComponentGrid OptionoverlayComponent
overlayComponentParams
overlayComponentSelector
Active OverlayGrid OptionactiveOverlay
activeOverlayParams
Drag and Drop ImageGrid OptiondragAndDropImageComponent
dragAndDropImageComponentParams
Status Bar ComponentGrid Option -> Status BarstatusPanel
statusPanelParams
Tool PanelGrid Option -> Side BartoolPanel
toolPanelParams
Toolbar Item ComponentGrid Option -> ToolbartoolbarItem
toolbarItemParams
Menu ItemGrid Option -> MenumenuItem
menuItemParams

Grid Provided Components Copy Link

The grid comes with pre-registered components that can be used. Each component provided by the grid starts with the namespaces 'ag' to minimise naming conflicts with user provided components. The full list of grid provided components are in the table below.

Drag And Drop
agDragAndDropImageDefault cover element when grid parts are being dragged
Date Inputs
agDateInputDefault date input used by filters
Column Headers
agColumnHeaderDefault column header
agColumnHeaderGroupDefault column group header
Column Filters
agSetColumnFilter (e)Set filter (default when using AG Grid Enterprise)
agTextColumnFilterSimple text filter (default when using AG Grid Community)
agNumberColumnFilterNumber filter
agDateColumnFilterDate filter
agMultiColumnFilter (e)Multi filter
agGroupColumnFilter (e)Group column filter
Floating Filters
agSetColumnFloatingFilter (e)Floating set filter
agTextColumnFloatingFilterFloating text filter
agNumberColumnFloatingFilterFloating number filter
agDateColumnFloatingFilterFloating date filter
agMultiColumnFloatingFilter (e)Floating multi filter
agGroupColumnFloatingFilter (e)Floating group column filter
Cell Components
agAnimateShowChangeCellRendererCell Component that animates value changes
agAnimateSlideCellRendererCell Component that animates value changes
agGroupCellRendererCell Component for displaying group information
agLoadingCellRenderer (e)Cell Component for loading row when using Enterprise row model
agSkeletonCellRendererCell Component for displaying skeleton cells
agCheckboxCellRendererCell Component that displays a checkbox for boolean values
Overlays
agLoadingOverlayLoading overlay
agNoRowsOverlayNo rows overlay
agNoMatchingRowsOverlayNo matching rows overlay
agExportingOverlayExporting overlay
Cell Editors
agTextCellEditorText cell editor
agSelectCellEditorSelect cell editor
agRichSelectCellEditor (e)Rich select editor
agLargeTextCellEditorLarge text cell editor
agNumberCellEditorNumber cell editor
agDateCellEditorDate cell editor
agDateStringCellEditorDate represented as string cell editor
agCheckboxCellEditorCheckbox cell editor
Master Detail
agDetailCellRenderer (e)Detail panel for master / detail grid
Column Menu / Context Menu
agMenuItem (e)Menu item within column or context menu

Overriding Grid Components Copy Link

It is also possible to override components. Where the grid uses a default value, this means the override component will be used instead. The default components, where overriding makes sense, are as follows:

  • agDragAndDropImage: To change the default drag and drop image when dragging grid parts.
  • agDateInput: To change the default date selection across all filters.
  • agColumnHeader: To change the default column header across all columns.
  • agColumnGroupHeader: To change the default column group header across all columns.
  • agLoadingCellRenderer: To change the default loading cell renderer for Enterprise Row Model.
  • agSkeletonCellRenderer: To change the default skeleton loading cell renderer for Enterprise Row Model.
  • agLoadingOverlay: To change the default 'loading' overlay.
  • agNoRowsOverlay: To change the default 'no rows' overlay.
  • agNoMatchingRowsOverlay: To change the default 'no matching rows' overlay.
  • agExportingOverlay: To change the default 'exporting' overlay.
  • agCellEditor: To change the default cell editor.
  • agDetailCellRenderer: To change the default detail panel for master / detail grids.
  • agMenuItem: To change the default menu item for column and context menus.
  • agTooltipComponent: To change the default tooltip component for all tooltips.

To override the default component, register the custom component in the GridOptions components property under the above name.

@Component({
    selector: 'my-app',
    template: `
        <ag-grid-angular
            [components]="components"
            ...other properties...
        />
    `
})
export class AppComponent {
    // Here is where we specify the components to be used instead of the default
    public components = {
        agDateInput: CustomDateComponent,
        agColumnHeader: CustomHeaderComponent
    };

AG Studio: Build dashboards using native components in web apps. Join us for a webinar on 28th July at 2pm UTC+1 Register

Vue Data GridCustom Components

Version 36.1.0

You can create your own Custom Components to customise the behaviour of the grid. For example you can customise how cells are rendered, how values are edited and also create your own filters.

The full list of component types you can provide in the grid are as follows:

The remainder of this page gives information that is common across all the component types.

Registering Custom Components Copy Link

The pages for each component type (cell renderer, cell editor etc) contain examples on how to register and use each component type. It is however useful here to step back and focus on the component registration process which is common across all component types.

Nuxt's auto-import component is not supported with custom components within the grid. Please register any custom components manually as described below.

Async components (e.g. defineAsyncComponent) are not supported as custom grid components. Use regular synchronous components instead.

Custom Components can be registered in two ways:

  • Globally
  • Locally using the components option
  • Locally using defineExpose with script setup

Global Component Registration Copy Link

import MyCustomerCellEditor from './App.vue'

app.component('MyCustomerCellEditor', MyCustomerCellEditor)

Locally using the components option Copy Link

import MyCustomerCellEditor from './App.vue'

export default {
  components: {
    MyCustomerCellEditor
  },
  setup() {
    // ...
  }
}

Locally using defineExpose with script setup Copy Link

<template>
  <ag-grid-vue v-model="rowData"
               :columnDefs="columnDefs"
               ...other props
  >
  </ag-grid-vue>
</template>

<script setup>
import MyCustomerCellEditor from './App.vue'

const columnDefs = ref([
    { field: "make", cellEditor: 'MyCustomerCellEditor' }
]);

...other setup

defineExpose({
    MyCustomerCellEditor    // make MyCustomerCellEditor available to the grid
})
</script>

Clicking on the Push For Total button will log results in the developer console.

Providing Additional Parameters Copy Link

Each Custom Component gets a set of parameters from the grid. For example, for Cell Component the grid provides, among other things, the value to be rendered. You can provide additional properties to the Custom Component (e.g. what currency symbol to use) by providing additional parameters specific to your application.

To provide additional parameters, use the property [prop-name]Params, e.g. cellRendererParams.

<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'price',
        cellRenderer: PriceCellRenderer,
        cellRendererParams: {
            currency: 'EUR'
        }
    },
];

Mixing JavaScript and Vue Copy Link

When providing Custom Components you have a choice of the following:

  1. Provide an AG Grid component in JavaScript.
  2. Provide an AG Grid component as an Vue Component.

For example if you want to build a cell renderer you have the choice to build the cell renderer using either Vue or using plain JavaScript.

The following code snippet shows how both JavaScript and Vue Components can be used at the same time:

<template>
  <ag-grid-vue :components="components"
               ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";
import JavascriptComponent from './JavascriptComponent.js';
import VueComponent from './VueComponent.vue';

export default {
  components: {
      AgGridVue,
      // Vue components are registered here
      'vueComponent': VueComponent
  }
  data() {
      return {
          // JavaScript components are registered here, for when looking up component by name
          components: {
              // declare the javascript component
              'javascriptComponent': JavascriptComponent
          },
          columnDefs: [
               {
                  headerName: "JS Cell",
                  field: "value",
                  cellRenderer: JavascriptComponent,    // reference/use the javascript component directly
              },
              {
                  headerName: "Vue Cell",
                  field: "value",
                  cellRenderer: 'vueComponent',  // reference/use the Vue component
              }
          ]
      }
  }
  //...other properties & methods
}
</script>

Change the documentation view to JavaScript to see how to create a plain JavaScript component.

Child to Parent Communication Copy Link

There are a variety of ways to manage component communication in Vue (shared service, local variables etc), but you often need a simple way to let a "parent" component know that something has happened on a "child" component. In this case the simplest route is to use the Grid's context feature to hold a reference to the parent, which the child can then access.

// Parent Grid Component
<template>
  <ag-grid-vue :context="context" ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports
import {AgGridVue} from "ag-grid-vue3";
import CubeComponent from './CubeComponent.vue';

export default {
  components: {
      AgGridVue
  }
  data() {
      return {
          context: {}
      }
  },
  beforeMount() {
      this.context = {
          componentParent: this
      }
  },
  methods: {
      parentMethod() {
          // do something
      }
  }
  //...other properties & methods
}
</script>

// Child Grid Component
<template>
  <ag-grid-vue ...other properties>
  </ag-grid-vue>
</template>

<script>
//...other imports

export default {
  methods: {
      doSomethingOnGrid() {
          // the grid component can now be accessed via this.params.context.componentParent
          this.params.context.componentParent.parentMethod()
      }
  }
  //...other properties & methods
}
</script>

Note that although we've used componentParent as the property name here it can be anything - the main point is that you can use the context mechanism to share information between the components.

Component Usage Copy Link

The below table gives a summary of the components, where they are configured and using what attribute.

ComponentWhereAttribute
Cell ComponentColumn DefinitioncellRenderer
cellRendererParams
cellRendererSelector
Editor ComponentColumn DefinitioncellEditor
cellEditorParams
cellEditorSelector
FilterColumn Definitionfilter
filterParams
Floating FilterColumn DefinitionfloatingFilter
floatingFilterParams
Date ComponentColumn DefinitiondateComponent
dateComponentParams
Header ComponentColumn DefinitionheaderComponent
headerComponentParams
Inner Header ComponentColumn DefinitioninnerHeaderComponent
innerHeaderComponentParams
Header Group ComponentColumn DefinitionheaderGroupComponent
headerGroupComponentParams
Inner Header Group ComponentColumn DefinitioninnerHeaderGroupComponent
innerHeaderGroupComponentParams
Tooltip ComponentColumn DefinitiontooltipComponent
tooltipComponentParams
Group Row Cell ComponentGrid OptiongroupRowRenderer
groupRowRendererParams
Group Row Inner Cell ComponentcellRendererParams
groupRowRendererParams
innerRenderer
innerRendererParams
Detail Cell ComponentGrid OptiondetailCellRenderer
detailCellRendererParams
Full Width Cell ComponentGrid OptionfullWidthCellRenderer
fullWidthCellRendererParams
Loading Cell ComponentGrid Option
Column Definition
loadingCellRenderer
loadingCellRendererParams
Overlay ComponentGrid OptionoverlayComponent
overlayComponentParams
overlayComponentSelector
Active OverlayGrid OptionactiveOverlay
activeOverlayParams
Drag and Drop ImageGrid OptiondragAndDropImageComponent
dragAndDropImageComponentParams
Status Bar ComponentGrid Option -> Status BarstatusPanel
statusPanelParams
Tool PanelGrid Option -> Side BartoolPanel
toolPanelParams
Toolbar Item ComponentGrid Option -> ToolbartoolbarItem
toolbarItemParams
Menu ItemGrid Option -> MenumenuItem
menuItemParams

Grid Provided Components Copy Link

The grid comes with pre-registered components that can be used. Each component provided by the grid starts with the namespaces 'ag' to minimise naming conflicts with user provided components. The full list of grid provided components are in the table below.

Drag And Drop
agDragAndDropImageDefault cover element when grid parts are being dragged
Date Inputs
agDateInputDefault date input used by filters
Column Headers
agColumnHeaderDefault column header
agColumnHeaderGroupDefault column group header
Column Filters
agSetColumnFilter (e)Set filter (default when using AG Grid Enterprise)
agTextColumnFilterSimple text filter (default when using AG Grid Community)
agNumberColumnFilterNumber filter
agDateColumnFilterDate filter
agMultiColumnFilter (e)Multi filter
agGroupColumnFilter (e)Group column filter
Floating Filters
agSetColumnFloatingFilter (e)Floating set filter
agTextColumnFloatingFilterFloating text filter
agNumberColumnFloatingFilterFloating number filter
agDateColumnFloatingFilterFloating date filter
agMultiColumnFloatingFilter (e)Floating multi filter
agGroupColumnFloatingFilter (e)Floating group column filter
Cell Components
agAnimateShowChangeCellRendererCell Component that animates value changes
agAnimateSlideCellRendererCell Component that animates value changes
agGroupCellRendererCell Component for displaying group information
agLoadingCellRenderer (e)Cell Component for loading row when using Enterprise row model
agSkeletonCellRendererCell Component for displaying skeleton cells
agCheckboxCellRendererCell Component that displays a checkbox for boolean values
Overlays
agLoadingOverlayLoading overlay
agNoRowsOverlayNo rows overlay
agNoMatchingRowsOverlayNo matching rows overlay
agExportingOverlayExporting overlay
Cell Editors
agTextCellEditorText cell editor
agSelectCellEditorSelect cell editor
agRichSelectCellEditor (e)Rich select editor
agLargeTextCellEditorLarge text cell editor
agNumberCellEditorNumber cell editor
agDateCellEditorDate cell editor
agDateStringCellEditorDate represented as string cell editor
agCheckboxCellEditorCheckbox cell editor
Master Detail
agDetailCellRenderer (e)Detail panel for master / detail grid
Column Menu / Context Menu
agMenuItem (e)Menu item within column or context menu

Overriding Grid Components Copy Link

It is also possible to override components. Where the grid uses a default value, this means the override component will be used instead. The default components, where overriding makes sense, are as follows:

  • agDragAndDropImage: To change the default drag and drop image when dragging grid parts.
  • agDateInput: To change the default date selection across all filters.
  • agColumnHeader: To change the default column header across all columns.
  • agColumnGroupHeader: To change the default column group header across all columns.
  • agLoadingCellRenderer: To change the default loading cell renderer for Enterprise Row Model.
  • agSkeletonCellRenderer: To change the default skeleton loading cell renderer for Enterprise Row Model.
  • agLoadingOverlay: To change the default 'loading' overlay.
  • agNoRowsOverlay: To change the default 'no rows' overlay.
  • agNoMatchingRowsOverlay: To change the default 'no matching rows' overlay.
  • agExportingOverlay: To change the default 'exporting' overlay.
  • agCellEditor: To change the default cell editor.
  • agDetailCellRenderer: To change the default detail panel for master / detail grids.
  • agMenuItem: To change the default menu item for column and context menus.
  • agTooltipComponent: To change the default tooltip component for all tooltips.

To override the default component, register the custom component in the GridOptions components property under the above name.

const MyApp = {
    // Here is where we specify the components to be used instead of the default
    components: {
        'ag-grid-vue': AgGridVue
        agDateInput: CustomDateComponent,
        agColumnHeader: CustomHeaderComponent
    },

Overridable grid components are the only components you need to additionally specify with components in order to tie their usage to the actual component. All other registration types specify their usage in column definitions or on the AgGridVue component itself.

For an example of this please refer to the Date Component documentation.

AG Studio: Build dashboards using native components in web apps. Join us for a webinar on 28th July at 2pm UTC+1 Register

React Data GridCustom Components

Version 36.1.0

You can create your own Custom Components to customise the behaviour of the grid. For example you can customise how cells are rendered, how values are edited and also create your own filters.

React Custom Components thumbnail

The full list of component types you can provide in the grid are as follows:

The remainder of this page gives information that is common across all the component types.

Registering Custom Components Copy Link

In versions <= v31, custom components were declared in an imperative way. See Migrating to Use reactiveCustomComponents for details on how to migrate to the current format.

There are two ways to register custom components:

  • Direct reference.
  • By name.

1. By Direct Reference Copy Link

When registering a React Component by reference you simply pass the Component to the place you want it used (i.e. Cell Renderer, Filter etc).

In this example we're specifying that we want our React CubeComponent as a Cell Renderer in the Cube column:

//...other imports
import CubeComponent from './CubeComponent';

const GridExample = () => {
  // other properties & methods

    const columnDefs = useMemo( () => [{field: 'value', cellRenderer: CubeComponent}], []);

    return (
        <AgGridReact
            columnDefs={columnDefs}
            ...other properties
        />
    );
};

The advantage of referencing Components directly is cleaner code, without the extra level of indirection added when referencing by name.

2. By Name Copy Link

When registering a React component by name you need to first register the component within the grid components property, then reference the component by name where you want it used (i.e. as a Cell Renderer, Filter etc).

In this example we've registered our React CubeComponent and given it a name of cubeComponent (this can be any name you choose). We then specify that we want the previously registered cubeComponent to be used as a Cell Renderer in the Cube column:

//...other imports
import CubeComponent from './CubeComponent';

const GridExample = () => {
  // other properties & methods

  const components = useMemo(() => ({
      cubeComponent: CubeComponent
  }), []);

  const columnDefs = useMemo(() => [{field: 'value', cellRenderer: 'cubeComponent'}], []);

  return (
        <AgGridReact
           components={components}
           columnDefs={columnDefs}
           ...other properties
        />
  );
};

The advantage of referencing components by name is definitions (eg Column Definitions) can be composed of simple types (ie JSON), which is useful should you wish to persist Column Definitions.

A React Component in this context can be any valid React Component - A Class Based Component, a Hook or even an inline Functional Component. The same rules apply regardless of the type of component used.

Clicking on the Push For Total button will log results in the developer console.

Providing Additional Parameters Copy Link

Each Custom Component gets a set of parameters from the grid. For example, for Cell Component the grid provides, among other things, the value to be rendered. You can provide additional properties to the Custom Component (e.g. what currency symbol to use) by providing additional parameters specific to your application.

To provide additional parameters, use the property [prop-name]Params, e.g. cellRendererParams.

const [columnDefs, setColumnDefs] = useState([
    {
        field: 'price',
        cellRenderer: PriceCellRenderer,
        cellRendererParams: {
            currency: 'EUR'
        }
    },
]);

<AgGridReact columnDefs={columnDefs} />

Mixing JavaScript and React Copy Link

When providing Custom Components you have a choice of the following:

  1. Provide an AG Grid component as a React Component.
  2. Provide an AG Grid component in JavaScript (JavaScript Class Components only, not JavaScript Functional Components).

The following code snippet shows how both JavaScript and React Components can be used at the same time:

//...other imports
import JavascriptComponent from './JavascriptComponent.js';
import ReactComponent from './ReactComponent';

const GridExample = () => {
  // JS and React components, only need register if looking up by name
  const components = useMemo(() => ({
      'javascriptComponent': JavascriptComponent,
      'reactComponent': ReactComponent
  }), []);

  const columnDefs = useMemo( () => [
      {
          headerName: "JS Cell",
          field: "value",
          cellRenderer: 'javascriptComponent', // JS comp by Name
      },
      {
          headerName: "JS Cell",
          field: "value",
          cellRenderer: JavascriptComponent, // JS comp by Direct Reference
      },
      {
          headerName: "React Cell",
          field: "value",
          cellRenderer: 'reactComponent', // React comp by Name
      },
      {
          headerName: "React Cell",
          field: "value",
          cellRenderer: ReactComponent, // React comp by Direct Reference
      }
  ], []);

    return (
        <AgGridReact
            components={components}
            columnDefs={columnDefs}
            ...other properties
        />
    );
};

Change the documentation view to JavaScript to see how to create a plain JavaScript component.

Higher Order Components Copy Link

If you use connect to use Redux, or if you're using a Higher Order Component (HOC) to wrap the grid React component, you'll also need to ensure the grid can get access to the newly created component. To do this you need to ensure forwardRef is set:

export default connect((state) => {
    return {
        currencySymbol: state.currencySymbol,
        exchangeRate: state.exchangeRate
    }
}, null, null, { forwardRef: true } // must be supplied for react/redux when using AgGridReact
)(PriceRenderer);

Component Usage Copy Link

The below table gives a summary of the components, where they are configured and using what attribute.

ComponentWhereAttribute
Cell ComponentColumn DefinitioncellRenderer
cellRendererParams
cellRendererSelector
Editor ComponentColumn DefinitioncellEditor
cellEditorParams
cellEditorSelector
FilterColumn Definitionfilter
filterParams
Floating FilterColumn DefinitionfloatingFilter
floatingFilterParams
Date ComponentColumn DefinitiondateComponent
dateComponentParams
Header ComponentColumn DefinitionheaderComponent
headerComponentParams
Inner Header ComponentColumn DefinitioninnerHeaderComponent
innerHeaderComponentParams
Header Group ComponentColumn DefinitionheaderGroupComponent
headerGroupComponentParams
Inner Header Group ComponentColumn DefinitioninnerHeaderGroupComponent
innerHeaderGroupComponentParams
Tooltip ComponentColumn DefinitiontooltipComponent
tooltipComponentParams
Group Row Cell ComponentGrid OptiongroupRowRenderer
groupRowRendererParams
Group Row Inner Cell ComponentcellRendererParams
groupRowRendererParams
innerRenderer
innerRendererParams
Detail Cell ComponentGrid OptiondetailCellRenderer
detailCellRendererParams
Full Width Cell ComponentGrid OptionfullWidthCellRenderer
fullWidthCellRendererParams
Loading Cell ComponentGrid Option
Column Definition
loadingCellRenderer
loadingCellRendererParams
Overlay ComponentGrid OptionoverlayComponent
overlayComponentParams
overlayComponentSelector
Active OverlayGrid OptionactiveOverlay
activeOverlayParams
Drag and Drop ImageGrid OptiondragAndDropImageComponent
dragAndDropImageComponentParams
Status Bar ComponentGrid Option -> Status BarstatusPanel
statusPanelParams
Tool PanelGrid Option -> Side BartoolPanel
toolPanelParams
Toolbar Item ComponentGrid Option -> ToolbartoolbarItem
toolbarItemParams
Menu ItemGrid Option -> MenumenuItem
menuItemParams

Grid Provided Components Copy Link

The grid comes with pre-registered components that can be used. Each component provided by the grid starts with the namespaces 'ag' to minimise naming conflicts with user provided components. The full list of grid provided components are in the table below.

Drag And Drop
agDragAndDropImageDefault cover element when grid parts are being dragged
Date Inputs
agDateInputDefault date input used by filters
Column Headers
agColumnHeaderDefault column header
agColumnHeaderGroupDefault column group header
Column Filters
agSetColumnFilter (e)Set filter (default when using AG Grid Enterprise)
agTextColumnFilterSimple text filter (default when using AG Grid Community)
agNumberColumnFilterNumber filter
agDateColumnFilterDate filter
agMultiColumnFilter (e)Multi filter
agGroupColumnFilter (e)Group column filter
Floating Filters
agSetColumnFloatingFilter (e)Floating set filter
agTextColumnFloatingFilterFloating text filter
agNumberColumnFloatingFilterFloating number filter
agDateColumnFloatingFilterFloating date filter
agMultiColumnFloatingFilter (e)Floating multi filter
agGroupColumnFloatingFilter (e)Floating group column filter
Cell Components
agAnimateShowChangeCellRendererCell Component that animates value changes
agAnimateSlideCellRendererCell Component that animates value changes
agGroupCellRendererCell Component for displaying group information
agLoadingCellRenderer (e)Cell Component for loading row when using Enterprise row model
agSkeletonCellRendererCell Component for displaying skeleton cells
agCheckboxCellRendererCell Component that displays a checkbox for boolean values
Overlays
agLoadingOverlayLoading overlay
agNoRowsOverlayNo rows overlay
agNoMatchingRowsOverlayNo matching rows overlay
agExportingOverlayExporting overlay
Cell Editors
agTextCellEditorText cell editor
agSelectCellEditorSelect cell editor
agRichSelectCellEditor (e)Rich select editor
agLargeTextCellEditorLarge text cell editor
agNumberCellEditorNumber cell editor
agDateCellEditorDate cell editor
agDateStringCellEditorDate represented as string cell editor
agCheckboxCellEditorCheckbox cell editor
Master Detail
agDetailCellRenderer (e)Detail panel for master / detail grid
Column Menu / Context Menu
agMenuItem (e)Menu item within column or context menu

Overriding Grid Components Copy Link

It is also possible to override components. Where the grid uses a default value, this means the override component will be used instead. The default components, where overriding makes sense, are as follows:

  • agDragAndDropImage: To change the default drag and drop image when dragging grid parts.
  • agDateInput: To change the default date selection across all filters.
  • agColumnHeader: To change the default column header across all columns.
  • agColumnGroupHeader: To change the default column group header across all columns.
  • agLoadingCellRenderer: To change the default loading cell renderer for Enterprise Row Model.
  • agSkeletonCellRenderer: To change the default skeleton loading cell renderer for Enterprise Row Model.
  • agLoadingOverlay: To change the default 'loading' overlay.
  • agNoRowsOverlay: To change the default 'no rows' overlay.
  • agNoMatchingRowsOverlay: To change the default 'no matching rows' overlay.
  • agExportingOverlay: To change the default 'exporting' overlay.
  • agCellEditor: To change the default cell editor.
  • agDetailCellRenderer: To change the default detail panel for master / detail grids.
  • agMenuItem: To change the default menu item for column and context menus.
  • agTooltipComponent: To change the default tooltip component for all tooltips.

To override the default component, register the custom component in the GridOptions components property under the above name.

const components = useMemo(() => (
    { agDateInput: CustomDateComponent,
        agColumnHeader: CustomHeaderComponent
    }), []);

<AgGridReact
    components={components}
    ...other properties...
/>